
#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "hdc.h"
#include "resource.h"
#include "file.h"
#include "tabasa_recorder.h"
#include "wav8bit.h"
#include "waveform.h"
#include "fileeditDlg.h"
#include "scroll.h"
#include "WaveEditOnPlaying.h"
#include "FileSave.h"
#include "SoundBuffer.h"
#include "SoundFileIO.h"
#include "MainDlg.h"


_extern char filenameRif[MAX_PATH];
_extern char filenameL[MAX_PATH];
_extern char filenameR[MAX_PATH];
_extern char filenameMIX[MAX_PATH];
_extern char filenameLR[MAX_PATH];
static TCHAR szNotStereoError[] = TEXT ("This is not stereo.");
static TCHAR szStartpositionError[] = TEXT ("position error.");


int volumerate=100;// ʒ߁A

void setvolumerate(int v)
{
	volumerate=v;
}

// f[^i16rbĝ݁jB@obt@AAu[XgB@I[o[t[ۂ߂B

void boostcalc(char* buffer, int size, float boost)
{
	long data;
	for(int ii=0;ii<size/sizeof(short);ii++) //boost
	{
		data=*((short*)buffer+ii);
		*((short*)buffer+ii)=checkoverflow16bit(data*boost);
	}
}



void filecutMix(ifstream &in,char *filenameLR,WAVEFORMATEX &waveformL,int L_R,DWORD size)
{
	//loadwave(pBuffer1, &datasize,&waveform,&format,&channels,&rate,&samplesize);

	if (samplesize!=16)return;//8bitۗ
	
	short data;
	long datal;
	DWORD c;
	char	*pBuffer,*pB;
	 char header[headersize];
	pBuffer=(char*)malloc(outbuffersize);

	pB=pBuffer;
	//ifstream	in(filename);
	reopensound(filename,in,header,headersize);
	in.seekg(headersize,ios::beg);//g`f[^͍
	ofstream	cut(filenameLR,ios::binary);
	writeheader(cut,waveformL,size/2);
	while(!in.eof())
	{
		in.read(pBuffer,outbuffersize);
		c=in.gcount();
		for(int i=0;i<c/sizeof(short)/2;i++)
		{
			datal=(*(short*)pBuffer)/2+(*((short*)pBuffer+1))/2;//;)(
			data=checkoverflow16bit(datal);
			//cut<<data;ǂ񂾐osizeof()
			cut.write((char*)&data,sizeof(short));//ǂ񂾐o
			pBuffer+=sizeof(short)*2;
		};
		pBuffer=pB;
	}	
	free(pB);

}


void filecut_position(BOOL monoralflag,ifstream &in,char *filenameLR,WAVEFORMATEX &waveformL,int L_R,DWORD size,unsigned long startpos, BOOL all)
{
	//loadwave(pBuffer1, &datasize,&waveform,&format,&channels,&rate,&samplesize);

	if (samplesize!=16)return;//8bitۗ
	
	float boost =(float)volumerate/100;
	DWORD c,t=0;
	char	*pBuffer,*pB,*pBnow;
	 char header[headersize];
	pBuffer=(char*)malloc(outbuffersize);

	pB=pBuffer;
	//ifstream	in(filename);
	reopensound(filename,in,header,headersize);
	in.seekg(headersize + sizeof(short)*L_R + startpos,ios::beg);//g`f[^͍
	ofstream	cut(filenameLR,ios::binary);
	if(monoralflag)writeheader(cut,waveformL,size/2);
	else writeheader(cut,waveformL,size);
	while(!in.eof() && (size>t || all) ) // Rs[TCY܂ASRs[Ȃ瑱
	{
		in.read(pBuffer,outbuffersize);
		c=in.gcount();
		t += c;
		boostcalc(pBuffer,c,boost);
		if(monoralflag==TRUE)
			for(int i=0;i<c/sizeof(short)/2;i++)
			{
				cut.write(pBuffer,sizeof(short));
				pBuffer+=sizeof(short)*2;
			}
		else 
		{
			if(t<size || all)cut.write(pBuffer,c);//ǂ񂾐o
			else cut.write(pBuffer,c-(t-size));
		}

		pBuffer=pB;
	}	
	free(pB);

}

void filecutSpeedUp(ifstream &in,char *filename,WAVEFORMATEX &waveform,DWORD size,DWORD buffersize,BOOL noiseflag,unsigned long cutpercent)
{
	if (samplesize!=16)return;//8bitۗ
	DWORD c,t=0;
	DWORD writinglen,writinglen2;
	DWORD startpos=0;
	short zerodata=0,ldata,rdata;
	short lstart,rstart,lend,rend;
	long lsa,rsa;
	long i;
	long outbuffersize=buffersize;
	char	*pBuffer,*pB,*pBnow;
	 char header[headersize];
	 char file[MAX_PATH];
	 makenewfilename(filename,file,"-up");
	pBuffer=(char*)malloc(outbuffersize);

	pB=pBuffer;
	reopensound(filename,in,header,headersize);
	in.seekg(headersize  + startpos,ios::beg);//g`f[^͍
	ofstream	cut(file,ios::binary);
	writinglen = (unsigned long)(size*((double)cutpercent/100)/4)*4;
	writeheader(cut,waveform,writinglen);
	while(!in.eof() && size>t)
	{
		in.read(pBuffer,outbuffersize);
		c=in.gcount();
		t += c;
		writinglen = (unsigned long)(c*((double)cutpercent/100)/4)*4;
			if(t<size)
				if(cutpercent<=100)//k
				{
					if(!noiseflag)cut.write(pBuffer,writinglen);//ǂ񂾐/2 o
					else 
					{
						cut.write(pBuffer,writinglen-noiseofflen);
						lstart=*(short*)(pBuffer+writinglen-noiseofflen);
						rstart=*(short*)(pBuffer+writinglen-noiseofflen+2);
						lend=*(short*)(pBuffer+c-4);
						rend=*(short*)(pBuffer+c-2);
						tsunagu(cut,lstart,rstart,lend,rend,noiseofflen);
					}
				}
				else //g
				{
					cut.write(pBuffer,c);
					lend=*(short*)(pBuffer+c-4);
					rend=*(short*)(pBuffer+c-2);
					writinglen2=min(writinglen-c,outbuffersize);
					in.read(pBuffer,writinglen2);
					in.seekg(-in.gcount(),ios::cur);
					cut.write(pBuffer,max(writinglen2-noiseofflen,0));
					lstart=*(short*)(pBuffer+writinglen2-noiseofflen-4);
					rstart=*(short*)(pBuffer+writinglen2-noiseofflen-2);
					tsunagu(cut,lstart,rstart,lend,rend,noiseofflen);
					/*
					for(i=0;i<(writinglen-c)/2/2;i++)
					{
						cut.write((char*)&ldata,2);
						cut.write((char*)&rdata,2);
					}
					*/
				}

		pBuffer=pB;
	}	
	free(pB);
	MessageBox(mainhwnd,"ok","file",MB_OK);
	
}

void filecut(ifstream &in,char *filenameLR,WAVEFORMATEX &waveformL,int L_R,DWORD size)
{
	filecut_position(TRUE,in,filenameLR,waveformL,L_R,size,0,FALSE);
}

void filecut_startend(ifstream &in,char *filenameRif,WAVEFORMATEX &waveformL,unsigned long startpos,unsigned long endpos)
{
	filecut_position(FALSE,in,filenameRif,waveformL,0,endpos-startpos,startpos,FALSE);
}


void filecut_split(ifstream &in,char *filenameold,WAVEFORMATEX &waveformL,ULONG size, DWORD num)
{
	char newfile[MAX_PATH];
	char buff[10];
	//̃TCYo,16bit,stereo
	size=size/num/12*12;

	for(DWORD i=0;i<num;i++)
	{
		makenewfilename(filenameold,newfile,i+1);//AԂŖOt
		filecut_position(FALSE,in,newfile,waveformL,0,size,size*i,FALSE);
	}
}



void filemixLR(char *filenameLR,char *filenameL,char *filenameR,WAVEFORMATEX &waveformL,DWORD size)
{
	//loadwave(pBuffer1, &datasize,&waveform,&format,&channels,&rate,&samplesize);

	if (samplesize!=16)return;//8bitۗ
	
	DWORD c;
	char	*pBufferL,*pBufferR,*pB_L,*pB_R;
	 char header[headersize];
	pBufferL=(char*)malloc(outbuffersize);
	pBufferR=(char*)malloc(outbuffersize);

	pB_L=pBufferL;
	pB_R=pBufferR;
	ifstream	inL(filenameL,ios::binary);
	ifstream	inR(filenameR,ios::binary);

	inL.seekg(headersize,ios::beg);//g`f[^͍
	inR.seekg(headersize,ios::beg);//g`f[^͍

	ofstream	mix(filenameLR,ios::binary);

	writeheader(mix,waveformL,size*2
		);
	while(!inL.eof())
	{
		inL.read(pBufferL,outbuffersize);
		inR.read(pBufferR,outbuffersize);
		c=inL.gcount();
		for(int i=0;i<c/sizeof(short);i++)
		{
			mix.write(pBufferL,sizeof(short));//ǂ񂾐o
			mix.write(pBufferR,sizeof(short));//ǂ񂾐o
			pBufferL+=sizeof(short);
			pBufferR+=sizeof(short);
		};
		pBufferL=pB_L;
		pBufferR=pB_R;
	}	
	free(pB_L);
	free(pB_R);

}

void realtimeend(char *file, WAVEFORMATEX *waveform)
{
	DWORD size=getwavesize(file);
	ofstream ou(file, ios::binary | ios::ate);
	writeheader(ou,*waveform,size);//
}

BOOL DlgFileSaveMain(WORD id, LPARAM lParam, ifstream *in, ofstream &ou, WAVEFORMATEX &waveform, WAVEFORMATEX &waveformLR)
{
	switch (id)
	{
		  case IDC_FILE_realtime:
			bRealtimeRecord = TRUE;
			ou.close();
			makenewfilename(filename,realtimename,"-real");
			ou.open(realtimename,ios::binary|ios::trunc);
			writeheader(ou,waveform,0);//
			  break;

          case IDC_FILE_mix_LR:
				loadwave(filenameL, &datasize,&waveform,&format,&channels,&rate,&samplesize);

			  if(channels==MONORAL)
			  {
					setwaveformRec(waveformLR,format,STEREO,rate,samplesize);
					filemixLR(filenameLR,filenameL,filenameR,waveformLR,datasize);
			  }
               return TRUE ;
               
			   
          case IDC_FILE_cut_all ://SRs[
			  loadwave(filename, &datasize,&waveform,&format,&channels,&rate,&samplesize);
			  setwaveformRec(waveformLR,format,channels,rate,samplesize);
			  filecut_position(FALSE,*in,filenameRif,waveformLR,0,0,0,TRUE);
			  return TRUE ;

          case IDC_FILE_cut_start_end ://؂
			  if(startpositionnow<endpositionnow)
			  {
					loadwave(filename, &datasize,&waveform,&format,&channels,&rate,&samplesize);

					setwaveformRec(waveformLR,format,channels,rate,samplesize);
					filecut_startend(*in,filenameRif,waveformLR,startpositionnow,endpositionnow);
			  }
			  else 
			  {
				  ShowError(szStartpositionError);
			  }
               return TRUE ;

		  case IDC_FILE_split:
			  if(lParam>0)
			  {
					loadwave(filename, &datasize,&waveform,&format,&channels,&rate,&samplesize);
					setwaveformRec(waveformLR,format,channels,rate,samplesize);

					filecut_split(*in,filename,waveformLR,datasize,lParam);
			  }
			  else 
			  {
				  ShowError(szStartpositionError);
			  }
               return TRUE ;
               
          case IDC_FILE_cut_L:
			  if(channels==STEREO)
			  {
					loadwave(filename, &datasize,&waveform,&format,&channels,&rate,&samplesize);

					setwaveformRec(waveformLR,format,MONORAL,rate,samplesize);
					filecut(*in,filenameL,waveformLR,LEFT,datasize);
			  }
			  else 
			  {
				  ShowError(szNotStereoError);
			  }
               return TRUE ;
               
          case IDC_FILE_cut_MIX:
			  if(channels==STEREO)
			  {
					loadwave(filename, &datasize,&waveform,&format,&channels,&rate,&samplesize);

					setwaveformRec(waveformLR,format,MONORAL,rate,samplesize);
					filecutMix(*in,filenameMIX,waveformLR,MIX,datasize);
			  }
               return TRUE ;
               
          case IDC_FILE_cut_R:
			  if(channels==STEREO)
			  {
					loadwave(filename, &datasize,&waveform,&format,&channels,&rate,&samplesize);

					setwaveformRec(waveformLR,format,MONORAL,rate,samplesize);
					filecut(*in,filenameR,waveformLR,RIGHT,datasize);
			  }
			  else 
			  {
				  ShowError(szNotStereoError);
			  }
               return TRUE ;
               
		  case IDC_SPEED_UP:
				loadwave(filename, &datasize,&waveform,&format,&channels,&rate,&samplesize);

			//	setwaveform(waveformLR,format,MONORAL,rate,samplesize);
				filecutSpeedUp(*in,filename,waveform,datasize,lParam,noiseflag,cutpercent);

				return TRUE;
	}
	return TRUE;
}