#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
//#include "hdc.h"
#include "resource.h"
//#include "file.h"
#include "tabasa_recorder.h"
#include "wav8bit.h"
//#include "fileeditDlg.h"
#include "scroll.h"
#include "FileSave.h"
#include "SoundFileIO.h"
#include "wavetrack.h"

char buffer[headersize];


void wtoint(WORD w,int *sampleps)
{
	sampleps[1]=HIBYTE(w);
	sampleps[0]=LOBYTE(w);
}

void dwtoint(DWORD dw,int *sampleps)
{
	wtoint(HIWORD(dw),sampleps+2);
	wtoint(LOWORD(dw),sampleps);
}

void inttow(char *sampleps,WORD *w)
{
	*w = MAKEWORD(*sampleps,*(sampleps+1));
}

void inttodw(char *sampleps,DWORD *dw)
{
	*dw=MAKELONG(MAKEWORD(*sampleps,*(sampleps+1)),MAKEWORD(*(sampleps+2),*(sampleps+3)));
}

//.......................................
//	قH

BOOL reopensound(char *filename,ifstream	&in,char *header,DWORD size)
{

	in.clear();//G[AP2001/11/21
	in.close();
	in.open(filename,ios::binary | ios::nocreate);
	if(in.eof()) return FALSE;
    
	//wave header check
	if(header!=NULL)in.read(header,headersize);
	in.seekg(size,ios::beg);
	return TRUE;
}


void SetWaveshot(int channel, int samplesize)
{
	waveshot =channel*samplesize/8;
}


BOOL loadwave (char *filename,DWORD *dwBytesRecorded,WAVEFORMATEX *wf,int *format,int *channels,long *rate,int *samplesize)
{
	DWORD dwd,chanksize;
	char *header=buffer;//header[headersize]
	BOOL flag=TRUE;
	unsigned  time=0;
	headerexsize=0x000;
	char* pBuffer;
	ifstream	in(filename,ios::binary);
          
	//wave header check
	in.read(header,headersize);
	if(in.gcount()<headersize)flag=FALSE;

	if(0!=strncmp(header,"RIFF",4))flag=FALSE;
	if(0!=strncmp(&header[0x08],"WAVE",4))flag=FALSE;
	if(0!=strncmp(&header[0x0c],"fmt ",4))flag=FALSE;

	//if(0!=strncmp(&header[0x024],"data",4))flag=FALSE;

	//inttodw(&header[0x028],dwBytesRecorded);
	*dwBytesRecorded =getwavesize(filename);//TCYAƂ肠f[^͖

	if(flag==FALSE)return flag;

	inttow(&header[0x014],(WORD*)format) ;
	inttow(&header[0x014],&wf->wFormatTag) ;
	inttow(&header[0x016],(WORD*)channels) ;
	inttow(&header[0x016],&wf->nChannels) ;
	inttodw(&header[0x018],(DWORD*)rate) ;
	inttodw(&header[0x018],&wf->nSamplesPerSec) ;
	inttodw(&header[0x01c],&wf->nAvgBytesPerSec) ;
	inttow(&header[0x020],&wf->nBlockAlign) ;
	inttow(&header[0x022],(WORD*)samplesize) ;
	inttow(&header[0x022],&wf->wBitsPerSample) ;
	//if(1 != wf->wFormatTag) flag=FALSE;//PCM
	inttodw(&header[0x010],&dwd) ;
	inttodw(&header[0x04],&chanksize) ;
	if(16 != dwd) //fmt`NftHgTCYłȂꍇ
	{
		//pBuffer=(char*)malloc(dwd+36);
		*dwBytesRecorded =getwavesize(filename);//TCYAƂ肠f[^͖
		in.seekg(16+4+dwd,ios::beg);
		headerexsize =dwd-16;
		while(!in.eof())
		{
			in.read(header,8);
			inttodw(&header[0x004],&dwd) ;
			if(0==strncmp(header,"data",4)) break;
			headerexsize +=(dwd+4+4);
			in.seekg(dwd,ios::cur);
		}
		flag=FALSE;
	}
	SetWaveshot(*channels,*samplesize);
	scrollminset();
	return TRUE ;
}

void writesizeonly(char *filename,DWORD size)
{
	int datasize[4];
	dwtoint(size+headersize-0x02c,datasize);
	wsprintf(buffer,"%ld oCg ...headerȊOׂwaveƂ",size);
	if(MessageBox (mainhwnd, buffer, filename,MB_ICONEXCLAMATION | MB_OKCANCEL) == IDOK ) 
	{
		ofstream ou(filename,ios::binary|ios::ate);//
		ou.seekp(headersize-8,ios::beg);
		ou<<"data";
		int i;
		if(size>0) for(i=0;i<4;i++)ou.put((unsigned char)datasize[i]);
		else for(i=0;i<4;i++)ou.put((unsigned char)255);
		MessageBox (mainhwnd, "wave TCY݂܂B", filename, MB_OK) ;
	}
}


//................................................
// header ݁Asize ́AEF[uf[^̃TCY


void writeheader(ofstream &ou,WAVEFORMATEX &waveform,DWORD size)
{

	
	int chanksize[4];
	dwtoint(size+headersize-8,chanksize);
	int formatchanksize[4];
	dwtoint(0x010,formatchanksize);//Œ
	int tag[2];//PCM
	wtoint(1,tag);
	int channels[2];
	wtoint(waveform.nChannels, channels);
	int sampleps[4];
	dwtoint(waveform.nSamplesPerSec, sampleps);
	int avg[4];
	dwtoint(waveform.nAvgBytesPerSec, avg);
	int block[2];
	wtoint(waveform.nBlockAlign, block);
	int bitps[2];
	wtoint(waveform.wBitsPerSample, bitps);
	int datasize[4];
	dwtoint(size+headersize-0x02c,datasize);


	ou.seekp(0,ios::beg);
	ou<<"RIFF";
	for(int i=0;i<4;i++)ou.put((unsigned char)chanksize[i]);
	ou<<"WAVE";
	ou<<"fmt ";
	for(i=0;i<4;i++)ou.put((unsigned char)formatchanksize[i]);
	for(i=0;i<2;i++)ou.put((unsigned char)tag[i]);
	for(i=0;i<2;i++)ou.put((unsigned char)channels[i]);
	for(i=0;i<4;i++)ou.put((unsigned char)sampleps[i]);
	for(i=0;i<4;i++)ou.put((unsigned char)avg[i]);
	for(i=0;i<2;i++)ou.put((unsigned char)block[i]);
	for(i=0;i<2;i++)ou.put((unsigned char)bitps[i]);
	ou<<"data";
	if(size>0) 
	{
		for(i=0;i<4;i++)ou.put((unsigned char)datasize[i]);
	}
	else for(i=0;i<4;i++)ou.put((unsigned char)255);
}

//........................................
//	EF[uTCY
//	ł͂ȂAdata`N݂̂ƂČvZ

DWORD getwavesize(char *buffname)
{
	//check length
	DWORD size=0;
	HANDLE f;
	f=CreateFile(buffname,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	size=max(GetFileSize(f,NULL)-headersize,0);
	CloseHandle(f);
	return size;
}

DWORD  saveone(WAVEFORMATEX &waveform,char *filename,char *buffname)
{
	DWORD size=0;
	//char	*pBuffer;
	size = getwavesize(buffname);
	if(size==0)
	{
		Comment("zero");
		return 0;
	}
	ofstream	out(buffname,ios::binary|ios::ate);
	writeheader(out,waveform,size);
	out.close();
	remove(filename);
	rename(buffname,filename);
	return size;
}


//
// obt@ۑt@CɃl[Aׂ̎͂

DWORD  saveall(WAVEFORMATEX &waveform,char *filename,int num)
{
	DWORD size =saveone(waveform, filename, buffname);
	char newfile[1000],newbuff[1000];
	for ( int c=1; c<=num; c++ )
	{
		makenewfilename(filename,newfile,c);
		makenewfilename(buffname,newbuff,c);
		size +=saveone(waveform, newfile, newbuff);
	}
	return size;
}


void StopAllSubSound()
{
	for (UINT i=0;i<effectfilemax;i++)
		ef[i].off();
}


void ResetAllSubSound()
{
	for (UINT i=0;i<effectfilemax;i++)
	{
		ef[i].reopensound();
		ef[i].setended(FALSE);
	}
}
