#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "resource.h"
#include "file.h"

//hFile
OPENFILENAME ofn;




//-----------------------------------------------------------------------
//	

void PopFileInitialize (HWND hwnd)
{
     static TCHAR szFilter[] = TEXT ("wave Files (*.wav)\0*.wav\0") \
                               TEXT ("All Files (*.*)\0*.*\0\0") ;
     
     ofn.lStructSize       = sizeof (OPENFILENAME) ;
     ofn.hwndOwner         = hwnd ;
     ofn.hInstance         = NULL ;
     ofn.lpstrFilter       = szFilter ;
     ofn.lpstrCustomFilter = NULL ;
     ofn.nMaxCustFilter    = 0 ;
     ofn.nFilterIndex      = 0 ;
     ofn.lpstrFile         = NULL ;          // Set in Open and Close functions
     ofn.nMaxFile          = MAX_PATH ;
     ofn.lpstrFileTitle    = NULL ;          // Set in Open and Close functions
     ofn.nMaxFileTitle     = MAX_PATH ;
     ofn.lpstrInitialDir   = NULL ;
     ofn.lpstrTitle        = NULL ;
     ofn.Flags             = 0 ;             // Set in Open and Close functions
     ofn.nFileOffset       = 0 ;
     ofn.nFileExtension    = 0 ;
     ofn.lpstrDefExt       = TEXT ("wav") ;
     ofn.lCustData         = 0L ;
     ofn.lpfnHook          = NULL ;
     ofn.lpTemplateName    = NULL ;
}

void setOpenFileExtTs1()
{
     static TCHAR szFilterTs1[] = TEXT ("ts1 Files (*.ts1)\0*.ts1\0") \
                               TEXT ("All Files (*.*)\0*.*\0\0") ;
     ofn.lpstrFilter       = szFilterTs1 ;
     strcpy("ts1",ofn.lpstrDefExt );
}

//-----------------------------------------------------------------------
//	

BOOL PopFileOpenDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName)
{
     ofn.hwndOwner         = hwnd ;
     ofn.lpstrFile         = pstrFileName ;
     ofn.lpstrFileTitle    = pstrTitleName ;
     ofn.Flags             = OFN_HIDEREADONLY | OFN_CREATEPROMPT ;
     
     return GetOpenFileName (&ofn) ;
}

//...................................
//	gqŐVt@C


void makenewfilename(char *filename,char *newfile,char *new_ad)
{
	char ext[6]="";
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(ext,"%s",pB+1);
		 wsprintf(pB,"%s.%s",new_ad,ext);
	 }
	 else wsprintf(newfile,"%s%s.%s",filename,new_ad,ext);
}

//...................................
//	gqŐVt@CAAԗp,max999


void makenewfilename(char *filename,char *newfile,DWORD num)
{
	char ext[6]="";
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(ext,"%s",pB+1);
		 wsprintf(pB,"_%03d.%s",num,ext);
	 }
	 else wsprintf(newfile,"%s_%03d.%s",newfile,num,ext);
}

//...................................
//	t@CA`FbN

BOOL checkfilename(char *filename,char *nextfile)
{
	char buff[MAX_PATH];
	ifstream in;
	char ext[6]="";
	ULONG num=0;
	char *pB;
	wsprintf(buff,filename);
	 pB=strrchr(buff,'_');
	 if(pB!=NULL) *pB='\0';
	 pB=strrchr(filename,'_');
	 if(pB!=NULL) 
	 {
		 pB++;
		 wsprintf(nextfile,pB);
		 pB=strrchr(nextfile,'.');
		 wsprintf(ext,pB+1);
		 *pB='\0';
		 sscanf(nextfile,"%d",&num);
		 wsprintf(nextfile,"%s_%03d.%s",buff,num+1,ext);
		 in.open(nextfile,ios::binary | ios::nocreate);
		 if(!in)
		 {
			 num=0;
			 wsprintf(nextfile,filename);
		 }

	 }
	 else 
	 {
		 pB=strrchr(filename,'\\');
		 if(pB!=NULL) pB++;
		 else pB=filename;
		 sscanf(pB,"%s",nextfile);
	 }

	 if(num>0) return TRUE;
	 else return FALSE;
}


//...................................
//	tH_ɐVt@C


void makenewfilename(char *filename,char *newfile,char *new_ad,char *ext)
{
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(pB,"%s.%s",new_ad,ext);
	 }
	 else wsprintf(newfile,"%s%s.%s",filename,new_ad,ext);
}

//NfBNg

void getini_ex(char*initial)
{
	char cdf[MAX_PATH],cddr[MAX_PATH],cddi[MAX_PATH];
	GetModuleFileName(NULL,cdf,MAX_PATH);
	_splitpath(cdf,cddr,cddi,NULL,NULL);
	wsprintf(initial,"%s\\%s",cddr,cddi);
}

	
//JgfBNg

void getini_cu(char*initial,char*initialfile)
{
	char cd[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,cd);
	wsprintf(initial,"%s\\%s",cd,initialfile);
}



BOOL checkmode(char *str1,char *ext) 
{
	BOOL ans;
	if(strchr(str1,'.')==NULL) ans=FALSE;
	else strncmp((strrchr(str1,'.')+1),ext,3)==0? ans=TRUE:ans=FALSE;
	return ans;
}