#ifndef _scroll
#define _scroll


_extern	HWND	hwndStartPlace,hwndEndPlace;
_extern	HWND	hwndScroll,hwndVolume,hwndBoost,hwndSpeed,hwndPitch,hwndPan ;

_extern long startplacemax;
_extern long startplacenow;
_extern long startplace;


_extern long endplacemax;
_extern long endplacenow;
_extern long endplace;

_extern long scrollmax;
_extern long scrollnow;
_extern long scrollp;

_extern long reverbsize;//=15000

#define  idBOOST	1
#define  idSCROLL	2
#define  idVOLUME	3
#define  idSPEED	4
#define  idPITCH	5
#define  idPAN		6

#define speedrplus	0.004
#define speedplus	0.004
#define levelplus	0.01
#define panplus	0.1
#define levelDefault	1.0
#define speedDefault	1.0
#define volumeDefault	1.4
#define speedmax	16.0
#define speedrmax	4.0
#define speedmin	0.0064
#define speedrmin	0.08
#define panmax		100
#define posstepmin  800
//#define reverbsizemax 15000
#define reverbsizeDefault 15000

#define levelmax	10.0
#define volumemax	2.0

_extern float	level,pan;
_extern float	volume;
_extern float	recVolume;
_extern float	speed,speedr;
_extern int	volumeright;
_extern int	volumeleft;

_extern POINT panp ;
_extern POINT pansize ;
_extern POINT boostp ;
_extern POINT boostsize ;
_extern POINT volumep ;
_extern POINT volumesize ;
_extern POINT recVolumesize ;
_extern POINT speedp ;
_extern POINT speedsize ;
_extern POINT pitchp ;
_extern POINT pitchsize ;

_extern long volume100;
_extern long volume100max;
_extern long volmeterx;
_extern long volmetery;
_extern float levelp;

void setboost(float);
void setboost(HWND &hwnd,HWND &hwndb,UINT id,float );
void setPan(HWND &hwnd,HWND &hwndb,UINT id,float);
void setspeed(float);
void setpitch(float);
void setvolume(float);
void scrollinit();
void TateScrollinit(HWND &parenthwnd,HWND &hwnd,int ID,int x1,int y1,int x2,int y2,long max);
void YokoScrollinit(HWND &parenthwnd,HWND &hwnd,int ID,int x1,int y1,int x2,int y2,long max);
void playscrollinit();
void startscrollinit();
void endscrollinit();
void volumescrollinit();
void panscrollinit(HWND &,HWND &,POINT vol,float&,float max);
void boostscrollinit(HWND &,HWND &,POINT vol,float&);
void editscrollinit(HWND &hwnd,HWND &hwndB,POINT vol,long &value,long max,long min);
void panscrollinit();
void boostscrollinit();
void speedscrollinit();
void pitchscrollinit();
void speedscroll(WPARAM);
void pitchscroll(WPARAM);
void scrollfnc(WPARAM wParam,long &scrollp,long scrollmax);
void scrollfnc(WPARAM wParam,long &scrollp,long scrollmax,ULONG &pos);
void volumescrollfnc(WPARAM,float &p,float max);
void boostscrollfnc(WPARAM,float &p,float max);
void waveeditscrollfnc(WPARAM wParam,long &value,long max);
void panscrollfnc(WPARAM,float &p,float min,float max);
void setvolume100(char *wavenow);
void setvolume100max(int samplesize);
void setwaveedit(HWND &hwnd,HWND &hwndw,long value);
void scrollminset();
ULONG getscrollmin();

#include "time.h"
#include <fstream.h>
BOOL DlgScrollMain(HWND lParam,WPARAM wParam, ifstream *in, HWAVEOUT &hWaveOut, time &now);


#endif _scroll