
#include <windows.h>
#include <iostream.h>
#include <fstream.h>
#include "sequence.h"
#include "wavetrack.h"
#include "defsize.h"

#ifndef _tabasa_recorder
#define _tabasa_recorder 

_extern ULONG	readsize;
_extern ULONG 	positionnow;
_extern ULONG 	startpositionnow;
_extern ULONG 	endpositionnow;
_extern ULONG   headerexsize;
_extern ULONG   recordedsize;
_extern ULONG   recbuffnum;
_extern ULONG   recordsizemax;

#define Commentseq( co ) 	setcomment(IDC_EDIT_seq,co)
#define Comment( co ) 	setcomment(IDC_EDIT_com,co)
#define levelcomment(d) 	setcomment(IDC_EDIT_volumeX,d)
#define DataSize(d) 	settext(IDC_EDIT_datasize,(d),"")
#define Time( t,d ) 	settexttime(IDC_EDIT_time,(t),(d))
#define backupname() wsprintf(backname,filename)
#define resetname() wsprintf(filename,backname)


_extern char header[headersize];
_extern BOOL levelcheckflag;
_extern BOOL noiseflag;
_extern BOOL pitchflag;
_extern BOOL langflag;
_extern BOOL seqplayflag;
_extern BOOL seqrecordingflag;
_extern BOOL RecStandBy;
_extern BOOL looprecflag;
_extern BOOL play16bitflag; //24bit16bitɂčĐ
_extern BOOL piconrecflag;	//wave 摜\,^
_extern BOOL feedbackflag;	//

_extern ULONG looprecsize;
_extern ULONG SoundJumpMax; //эől
#define SoundJumpMaxMin 1	

#define RepeatON -1
#define RepeatOFF 1
_extern signed flagrepeat;

_extern BOOL bRecording, bPlaying, bReverb, bReverse, bPaused,
             bRecordingPaused, bEnding, bTerminating,flagStartEnd,bClick,
			 bRealtimeRecord,bRepairSoundJump;
_extern BOOL markplayflag,markplayend;

#define LANG_JP TRUE
#define LANG_ENG FALSE


_extern WaveTrack w,*ef;//[effectfilemax],*eftes;//ef;[10],
_extern ofSequence seq;
_extern ifSequence seqIn;



#define MAXMARK	"+"


_extern int	samplesize;
_extern int	playsamplesize;


_extern char thisname[45];

static TCHAR szAppName [] = TEXT ("tabasa_recorder") ;
static char szLoadError [] = TEXT ("error,in load!") ;
static TCHAR        szMemError [] = TEXT ("Error allocating memory!") ;
_extern char buffname[MAX_PATH];
_extern char backname[MAX_PATH];


_extern char pathname[MAX_PATH];
_extern char realtimename[MAX_PATH];
_extern char titlename[MAX_PATH];

_extern unsigned long 	BPSstep;

#ifdef _main


int	rateup=ratebase*4;

int	skiprate=240;
/*
							270,380,
							127, 10,*/

int zerochecksize=6;
unsigned long 	dwTimenow = 0 ;
//char 

#define setfilenames() {makenewfilename(filename,filenameRif,"_Rif");\
						makenewfilename(filename,filenameC1,"_1");\
						makenewfilename(filename,filenameC2,"_2");\
						makenewfilename(filename,filenameR,"_R");\
						makenewfilename(filename,filenameL,"_L");\
						makenewfilename(filename,filenameMIX,"_M");\
						makenewfilename(filename,filenameMIX,"_LR");\
						makenewfilename(filename,seq.getName(),"",seq_ext);\
						}

char filenameC1[MAX_PATH]="record_1.wav";
char filenameC2[MAX_PATH]="record_2.wav";
char filenameRif[MAX_PATH]="record_Rif.wav";
char filenameL[MAX_PATH]="record_L.wav";
char filenameR[MAX_PATH]="record_R.wav";
char filenameMIX[MAX_PATH]="record_M.wav";
char filenameLR[MAX_PATH]="record_LR.wav";
static TCHAR szHeaderError [] = TEXT ("Error Header!") ;

char initial[MAX_PATH]="tabasa_recorder.ini";
char seq_ext[]="ts1";

#endif _main


_extern int format;
_extern long rate;
_extern int	channels;
_extern DWORD datasize;
_extern float raterate;
_extern int waveshot;


BOOL CALLBACK DlgProc (HWND, UINT, WPARAM, LPARAM) ;
_extern	HINSTANCE hInstance;
_extern	HWND	mainhwnd ;//hwndmain,
//LRESULT CALLBACK VolumeProc (HWND, UINT, WPARAM, LPARAM) ;
_extern	WNDPROC OldVolume;


#define effectfilemax 200
_extern ULONG effectfilenum;
#define effectfilenumstep 5

_extern char initialfile[MAX_PATH];
_extern char filename[MAX_PATH];
_extern char effectfilename[effectfilemax][MAX_PATH];
_extern char commandline[MAX_PATH];


#endif _tabasa_recorder

void setcomment(int ,char *);
void initialize(ifstream &,char *);
void writeinit(ofstream &);
void ondestroy(char *);
void setVolume(int , int );
//void settext(int id,unsigned long value,char *after);
