#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
//#include "hdc.h"
#include "resource.h"
//#include "file.h"
#include "tabasa_recorder.h"
#include "SoundBuffer.h"
#include "scroll.h"
#include "wavebit.h"
#include "parameter.h"

parameter picskip(def_picskip,def_picskip,4,0);

void initpicskip()
{
	picskip.reset();
}

parameter *getpicskip()
{
	return &picskip;
}

void readonedata(ifstream &in, PBYTE &buffer, ULONG step)
{
	char data[2];
	//ULONG stepend=0;
	ULONG skip=step/max(picskip.getdata(),1)/4*4;
	//ڂ̃f[^
	in.read(data,2);
	*(short*)buffer=*(short*)data;
	*((short*)buffer+2)=*(short*)data;
	in.read(data,2);
	*((short*)buffer+1)=*(short*)data;
	*((short*)buffer+3)=*(short*)data;
	for(int j=0;j<7;j++) in.seekg(skip+4,ios::cur);

	for (ULONG i=8; i*(skip+4)<step; i++)
	{
		in.read(data,2);
		*(short*)buffer = max(*(short*)buffer, *(short*)data);//ő
		*((short*)buffer+2) = min(*((short*)buffer+2), *(short*)data);//ŏ
		in.read(data,2);
		*((short*)buffer+1) = max(*((short*)buffer+1), *(short*)data);//ő
		*((short*)buffer+3) = min(*((short*)buffer+3), *(short*)data);//ŏ
		
		for(int j=0;j<7;j++) in.seekg(skip+4,ios::cur);
		i+=8;
	}

}



void readallsoundpic(PBYTE &buffer, char *filename, ULONG step, ULONG size)
{
	static BOOL flag=FALSE;
	if(flag) return;//ƒ͂^[
	flag=TRUE;

	PBYTE now;
	now=buffer;
	memset(buffer,0,size);
	ULONG sizenow=0;
	ifstream in(filename,ios::binary);
	//in.read(buffer,headersize);
	in.seekg(positionnow +datapos(),ios::beg);

	while (in && !in.eof() && sizenow<size)
	{
		readonedata(in,now,step);
		now = now+sizeof(short)*4;
		sizenow+= sizeof(short)*4;
	}
	flag=FALSE;
}

void resetmembuffersize()
{
	membufferrate=def_bufferrate;
	membuffersize=def_buffersize *membufferrate;
	oldbuffersize=membuffersize;
}


// membuffersize w̒lɖ߂ix`FbN̂Ɓj

void setmembuffersize()
{
	membuffersize=oldbuffersize;
}

void downmembuffersize()
{
	if(membuffersize >def_buffersize)membuffersize -=def_buffersize/2;
	else membuffersize /=2;
	oldbuffersize=membuffersize;
}

void upmembuffersize()
{
	if(membuffersize +def_buffersize > def_buffersizeMax)return;
	if(membuffersize >=def_buffersize) membuffersize +=def_buffersize/2;
	else membuffersize *=2;
	oldbuffersize=membuffersize;
}

void initBuffer()
{
	readbuffersizemax =def_buffersizeMax * speedmax;
	levelchecksize=def_levelchecksize;
	resetmembuffersize();
	readbuffersize=def_buffersize;
	readspeedsize=def_buffersize;
	outbuffersize=def_buffersize;//1

}

//--------------------------------------
//	obt@̐擪A傫邩,16rbg

BOOL zerocheck(PBYTE &pSkipBuffer,int rep)
{
	BOOL	flag=TRUE;
	short sounddata;
	short *pS=(short *)pSkipBuffer;
	long level=(float)nextzero/100*bit16max;
	for(;0<rep;rep--)
	{
		sounddata=*(pS++);
		if(sounddata>level || sounddata<-level)
		{
			flag= FALSE;
			rep=0;
		}
	}
	return flag;
}

BOOL errorcheck(HWND hwnd,PBYTE *pBuffer)
{
	BOOL result = FALSE ;
	for(int i=0;i<bufferNum;i++)if (!pBuffer[i] )result = TRUE ;

	if (result == TRUE)
	{
		for(int i=0;i<bufferNum;i++)free (pBuffer[i]) ;

		MessageBeep (MB_ICONEXCLAMATION) ;
		MessageBox (hwnd, szMemError, szAppName,
				MB_ICONEXCLAMATION | MB_OK) ;
		return TRUE ;
	}
	return FALSE ;
}


void loadbuff(PBYTE &pSaveBuffer,DWORD datasize,char *buffname)
{

	ifstream in(buffname,ios::binary);
	in.read(pSaveBuffer,datasize);
}

void buffreset()
{
	ofstream	ou(buffname,ios::binary|ios::trunc);
}


void setreadbuffersize()
{
	readbuffersize =((unsigned long)((float)membuffersize * speed/waveshot))*waveshot;
	//if(play16bitflag)readbuffersize *= 1.5;
	readbuffersize = min(readbuffersize,readbuffersizemax);
}

void initReadBuffer(PBYTE &pReadBuffer)
{
	free(pReadBuffer);
	pReadBuffer = (PBYTE)malloc (readbuffersizemax) ;
}


void OpenRecBuffer(ofstream &ou, char *file)
{
	ou.open(file,ios::binary|ios::ate);
}

void OpenRecBuffer(ofstream &ou, char *file, ULONG num)
{
	char newfile[1000];
	makenewfilename(file,newfile,num);
	ou.open(newfile,ios::binary);
}

void OpenRecBuffer(ofstream &ou)
{
	OpenRecBuffer(ou, buffname);
}


void nextbuff(ofstream &ou, ULONG buffnum)
{
	ou.close();
	OpenRecBuffer(ou, buffname, buffnum);
}


