#include "defextern.h"

#include <stdio.h>
//#include <iostream.h>
//#include <fstream.h>
#include <windows.h>
//#include "hdc.h"
#include "resource.h"
#include "file.h"
#include "tabasa_recorder.h"
#include "SoundBuffer.h"
#include "SubSoundSetting.h"
#include "WaveEditOnPlaying.h"
#include "MainDlg.h"
#include "scroll.h"
#include "wavepitch.h"

long bufferNumnow;
long sleepmax=3000;

void resetbuffernumnow(int num)
{
	bufferNumnow=num;
}

void	allwaveoutreset(HWAVEOUT &hWaveOut,PWAVEHDR  *pWaveHdr)	
{
			for(int i=0;i< bufferNum;i++)
			{
				waveOutUnprepareHeader (hWaveOut, pWaveHdr[i], sizeof (WAVEHDR)) ;
			}
			waveOutReset (hWaveOut) ;
			waveOutClose (hWaveOut) ;//Ȃ?
}


void waveoutunprepare(HWAVEOUT &hWaveOut,PWAVEHDR  pwavehdr)
{
	bufferNumnow--;
	waveOutUnprepareHeader (hWaveOut, pwavehdr, sizeof (WAVEHDR)) ;
	if(bufferNumnow<=0) 
	{
		waveOutClose (hWaveOut) ;
	}
}


void allwaveoutclose(HWAVEOUT &hWaveOut, PWAVEHDR* pWaveHdr)
{
	for(int i=0;i<bufferNum;i++)
		waveOutUnprepareHeader (hWaveOut, pWaveHdr[i], sizeof (WAVEHDR)) ;
	waveOutClose (hWaveOut) ;
}

ULONG datapos()
{
	return headersize +headerexsize ;
}

BOOL skip(char *buff)
{
	if(markplayflag && !markplayend && w.getskipnum()>0 && *(w.getskipnow()->getstart())<positionnow) 
	{
		sprintf(buff,"%d",*w.getskipnow()->getstart());
		Commentseq(buff);
		positionnow= (*(w.getskipnow()->getend()))/waveshot*waveshot; //ςȈʒuɂȂȂ悤
		w.setskipnumnownext();
		if(w.getskipnow()->getnext()==NULL) markplayend=TRUE;
		return TRUE;
	}
	else return FALSE;
}

void endrepeat(ULONG &pos)
{
	if(w.in.eof()	&&	(flagrepeat==RepeatON))
	{
		w.reopensound(header,datapos());
		pos=0;
	}
}

void showsubnum()
{
	if(SubSoundSettingHwnd!=NULL) 
		SendMessage (SubSoundSettingHwnd, WM_COMMAND, IDC_SHOW_SUB_NUM, 0L) ;
}

void setscroll(ULONG pos)
{
	scrollnow=pos*1.0/datasize*scrollmax;
	scrollp=scrollnow-1;
	SetScrollPos  (hwndScroll, SB_CTL, scrollnow, TRUE) ;
}

void startend(ULONG &pos)
{
	if( (flagStartEnd == TRUE) && (pos +readbuffersize >endpositionnow) )
	{
		if(flagrepeat==RepeatOFF) bEnding = TRUE;
		else
		{
			pos=startpositionnow;
			w.in.seekg(pos +datapos(),ios::beg);
		}
	}
}

void reverse()
{
	if( bReverse == TRUE )
	{
		if(!w.in.seekg(-readbuffersize,ios::cur)) bEnding = TRUE;
	}
}

void autoplay(char *buff, ULONG &pos)
{
	if(w.in.eof()	&&	(flagrepeat==RepeatOFF) && autoplayflag)
	{
		if(checkfilename(filename,buff))
		{
			wsprintf(filename,buff);
			w.reopensound(filename,header,datapos());
		}
		else
		{
			bEnding =TRUE;
		}
		pos=0;
		title(mainhwnd,filename,thisname);
	}

}

void effectplus()
{
	for(int i=0;i<effectfilemax;i++)
	{
		if(!ef[i].getplaying() && ef[i].getrecorded() && !ef[i].getended() && positionnow>ef[i].getposition() )
		{
			ef[i].setplaying();
			ef[i].setended();
		}
		if(ef[i].getplaying()) 
		{
			ef[i].in.read(pReadBuffer,readspeedsize);
			ef[i].getpositionnow() +=ef[i].in.gcount();
			EffectPlusMemory(pSaveBuffer, pReadBuffer,readspeedsize,ef[i].in.gcount(),ef[i].getboost(),ef[i].getlastboost(),ef[i].getPan(),ef[i].getlastPan());
			if(ef[i].in.eof()) 
			{
				ef[i].setplaying(FALSE);
				ef[i].reopensound(header,headersize);
			}
		}
	}
}


void reversefnc()
{
	if( bReverse == TRUE )
	{
		ReverseMemory (pSaveBuffer, readspeedsize) ;
		w.in.seekg(-readsize,ios::cur);
	}
}

// 24bit >16bit (ʂWbit)

void play16bit(PBYTE &pBuffer, DWORD readsize)
{
	if(readsize<6) return;
	//memset(pBuffer,0,readsize);
	DWORD i =readsize;
	DWORD zer=readsize/3;
	PBYTE from,to;
	from =pBuffer;
	to =pBuffer;
	do
	{
		*to = *from;
		*(to+1) = *(from+1);
		i -=3;
		from +=3;
		to +=2;
	} while(i>2);
//	memset(to+2,0,zer);
}

void reopen()
{
	w.reopensound(header,datapos());
	positionnow=0;
	if(flagrepeat==RepeatOFF) bEnding = TRUE;
}

void reverbfnc()
{
	if( bReverb == TRUE )
	{
		adReverbMemory (pSaveBuffer, readspeedsize, reverbsize) ;
	}
	else if(LevelMemory (pSaveBuffer, readspeedsize, level,w) )levelcomment(" ");
	else levelcomment(MAXMARK);
}

void readmain()
{
	ULONG size;
	ULONG sendsize;
	size =readbuffersize;
	if(play16bitflag) size *=1.5;
	if(!w.read(pReadBuffer,size/waveshot*waveshot)) //readbuffersize
	{
		reopen();
	}
	sendsize=w.in.gcount();
	if(play16bitflag) 
	{
		play16bit(pReadBuffer, sendsize);
		sendsize=sendsize/1.5;
	}
	readsize=sendsize;
	if(readsize<1) bEnding =TRUE;
}

void effectmain()
{
	readspeedsize =((ULONG)((double)readsize/speed/waveshot))*waveshot;
	npos.setmaxmin((long)(readspeedsize/4-1),0);//PUrbgAXeI
	changebyspeed(pReadBuffer,pSaveBuffer,speed,pitch,readsize,membuffersize);//readspeedsize
	reversefnc();
	reverbfnc();
	effectplus();
}

void readprepare(BOOL &skipf, char *buff, PWAVEHDR &pwavehdr)
{
	skipf =skip(buff);
	Time(positionnow,BPSstep);
	showsubnum();
	setscroll(positionnow);
	reverse();
	startend(positionnow);
	
	pSaveBuffer = (PBYTE )(pwavehdr->lpData);
	endrepeat(positionnow);
	autoplay(buff, positionnow);
}

void readafter()
{
	memset(pSaveBuffer+readspeedsize, 0, membuffersize-readspeedsize);
	positionnow +=readsize;
}

void soundbuffermain(PWAVEHDR &pwavehdr,ULONG &positionnow,ofstream &ou,HWAVEOUT &hWaveOut,PWAVEHDR *pWaveHdr,DWORD &readsize)
{
	BOOL skipflag=FALSE;
	char buff[MAX_PATH];

	readprepare(skipflag, buff, pwavehdr);
	if( bEnding ==	TRUE ||	(w.in.eof() && (flagrepeat==RepeatOFF))  )
		waveoutunprepare(hWaveOut, pwavehdr);
	else
	{
		if(skipflag) w.in.seekg(positionnow+readsize,ios::beg);
		//݂
		readmain();
		effectmain();
		readafter();
		waveOutPrepareHeader (hWaveOut,pwavehdr , sizeof (WAVEHDR)) ;
		waveOutWrite (hWaveOut, pwavehdr, sizeof (WAVEHDR)) ;
		if(bRealtimeRecord)
			ou.write(pSaveBuffer, readspeedsize);
	}
}