
//---------------------------------------------------------
//	dialog 

#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>

#include "resource.h"
#include "tabasa_recorder.h"
#include "fileeditDlg.h"
#include "FileSave.h"


BOOL CALLBACK FileEditProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char buff[MAX_PATH];
	static int nownum, rate;
     switch (message)
     {
		case WM_INITDIALOG:
			SetWindowText(hwnd,DlgTitle);
			rate=100;
			  sprintf(buff,"%d",16384);
			  SetDlgItemText(hwnd,IDC_buffersize,buff);
			  sprintf(buff,"%d",50);
			  SetDlgItemText(hwnd,IDC_cut_percent,buff);
			  sprintf(buff,"%d",rate);
			  SetDlgItemText(hwnd,IDC_volume_rate,buff);
		//	makefilename(oldfile,ext,file);
		//	sprintf(oldfile,"%s-old.%s",oldfile,ext);
			nownum=1;
			SendMessage (hwnd, WM_COMMAND, IDC_NOISE_OFF, 0L) ;
			break;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {//
		  case IDC_SPEED_UP:
			  GetDlgItemText(hwnd,IDC_buffersize,buff,20);
			  sscanf(buff,"%d",&lParam);
		  case IDC_FILE_realtime:
		  case IDC_FILE_mix_LR:
		  case IDC_FILE_cut_L:
		  case IDC_FILE_cut_R:
		  case IDC_FILE_cut_MIX:
		  case IDC_FILE_cut_start_end:
		  case IDC_FILE_cut_all:
			  rate =GetDlgItemInt(hwnd,IDC_volume_rate,NULL, FALSE);
			  setvolumerate(rate);
				SendMessage (mainhwnd, WM_COMMAND, wParam,lParam) ;
				break;

		  case IDC_FILE_split:
			  GetDlgItemText(hwnd,IDC_split_num,buff,20);
			  sscanf(buff,"%d",&lParam);
				SendMessage (mainhwnd, WM_COMMAND, wParam,lParam) ;
				break;

		  case IDC_cut_percent:
			  GetDlgItemText(hwnd,IDC_cut_percent,buff,20);
			  sscanf(buff,"%d",&lParam);
				SendMessage (mainhwnd, WM_COMMAND, wParam,lParam) ;
			  break;

		  case IDC_NOISE_OFF:
			  if(noiseflag) 
				  SetDlgItemText(hwnd,IDC_NOISE_OFF,"cut-only");
			  else 
				  SetDlgItemText(hwnd,IDC_NOISE_OFF,"noise-off");
				SendMessage (mainhwnd, WM_COMMAND, wParam,lParam) ;
				break;


          case IDOK:
          case IDCANCEL:
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
               return TRUE ;


		  }
		  break;

		case WM_SYSCOMMAND:
			switch (LOWORD (wParam))
			{
				case SC_CLOSE:
					EndDialog (hwnd, 0) ;
				return TRUE ;
			}
			break ;
          
	}
	 return FALSE;
}
